#include <WiFi.h>
#include <FastLED.h>
#include <WiFiClient.h>
#include <WebServer.h>
#include <ESPmDNS.h>
#include <Update.h>
#include <EEPROM.h>

const char* host     = "esp32_vu";
const char* ssid     = "simnet24";
const char* password = "tenomWLAN84321!";

#define BOARD_LED 2
//#define DAC1 25
#define DAC2 26 // drives adc input to avoid non-linear area
//#define DAC_LIMIT 80
//#define CALIB_THR 256
#define CALIB_ADC_VAL 15
#define ADC_OFFSET_L (-890)
#define ADC_OFFSET_R (-890)
#define LED_PIN_LEFT     16
#define LED_PIN_RIGHT    17
#define NUM_LEDS    64
#define CHIPSET     WS2811
#define COLOR_ORDER GRB
CRGBArray<NUM_LEDS> leds[2];

#define BRIGHTNESS_VLOW  10
#define BRIGHTNESS_LOW  50
#define BRIGHTNESS_HIGH  100
#define PEAK_TIME   2000

int leftChannel = 34; //analog pin
int rightChannel = 35; //analog pin
int lmax, rmax, ravg, rsum, lavg, lsum;
int lmax_lterm, rmax_lterm, volume_filt;

int addLedsConstant = 0 ; //how fast are LEDS added to bar
int removeLedsTimeConstant = 20; //how fast are LEDS removed from bar
int middleColorLED = 25;
int peakpos[2];
long peaktime[2];
int server_ok;
int upload_run;

int numLedsToLight[2];
long lastRefreshTime[2];

#define LG_VOL 4095
#define MG_VOL 1024
#define HG_VOL 400

WebServer server(80);
int sample_cnt = 512;
struct eedata_st {
  int gl_volume;
  int color_sch;
  int peak_show;
  int brightness;
  int drop_speed;
  int ana_scale;
  int ana_mix;
  int seg8;
  int autogain;
} eedata;

const char* serverIndex = 
"<html><head><title>VU METER UPDATER</title></head><script src='https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js'></script>"
"<form method='POST' action='#' enctype='multipart/form-data' id='upload_form'>"
   "<input type='file' name='update'>"
        "<input type='submit' value='Update'>"
    "</form><p><a href=/>back</a></p>"
 "<div id='prg'>progress: 0%</div>"
 "<script>"
  "$('form').submit(function(e){"
  "e.preventDefault();"
  "var form = $('#upload_form')[0];"
  "var data = new FormData(form);"
  " $.ajax({"
  "url: '/update',"
  "type: 'POST',"
  "data: data,"
  "contentType: false,"
  "processData:false,"
  "xhr: function() {"
  "var xhr = new window.XMLHttpRequest();"
  "xhr.upload.addEventListener('progress', function(evt) {"
  "if (evt.lengthComputable) {"
  "var per = evt.loaded / evt.total;"
  "$('#prg').html('progress: ' + Math.round(per*100) + '%');"
  "}"
  "}, false);"
  "return xhr;"
  "},"
  "success:function(d, s) {"
  "console.log('success!')" 
 "},"
 "error: function (a, b, c) {"
 "}"
 "});"
 "});"
 "</script>";
String mainForm = 
"<html><head><title>VU METER</title></head><body><h3>Simons LED VU-Meter</h3><p>"
"Click <a href=\"/GH\">here</a> to set high gain.<br>"
"Click <a href=\"/GM\">here</a> to set medium gain.<br>"
"Click <a href=\"/GL\">here</a> to set low gain.<br>"
"Click <a href=\"/GU\">here</a> to increase gain by 10 percent.<br>"
"Click <a href=\"/GD\">here</a> to decrease gain by 10 percent.<br>"
"Current gain: #gl_volume (lower number = higher gain)<br><br>"
"Click <a href=\"/AG0\">here</a> to disable autogain.<br>"
"Click <a href=\"/AG1\">here</a> to enable autogain.<br>"
"Current autogain setting: #autogain<br><br>"
"Click <a href=\"/BH\">here</a> to set high brightness. ATTENTION: use only with power supply!<br>"
"Click <a href=\"/BL\">here</a> to set low brightness.<br>"
"Click <a href=\"/BVL\">here</a> to set very low brightness.<br>"
"Click <a href=\"/BU\">here</a> to increase brightness by 10.<br>"
"Click <a href=\"/BD\">here</a> to descrease brightness by 10.<br>"
"Current brightness: #brightness<br><br>"
"Click <a href=\"/C0\">here</a> to set colors (0) green-yellow-red.<br>"
"Click <a href=\"/C1\">here</a> to set colors (1) blue-red.<br>"
"Click <a href=\"/C2\">here</a> to set colors (2) light-blue-yellow.<br>"
"Click <a href=\"/C3\">here</a> to set colors (3) light-blue-red (no transition).<br>"
"Click <a href=\"/C4\">here</a> to set colors (4) green-yellow.<br>"
"Click <a href=\"/C5\">here</a> to set colors (5) orange-red.<br>"
"Current colors: #color_sch<br><br>"
"Click <a href=\"/80\">here</a> to set 64 segments (0).<br>"
"Click <a href=\"/81\">here</a> to set 8 segments (1).<br>"
"Current segments: #seg8<br><br>"
"Click <a href=\"/P0\">here</a> to show no peaks.<br>"
"Click <a href=\"/P1\">here</a> to show peaks.<br>"
"Current peaks: #peak_show<br><br>"
"Click <a href=\"/D0\">here</a> to have drop as instant off (0).<br>"
"Click <a href=\"/D1\">here</a> to set fast drop speed (1).<br>"
"Click <a href=\"/D2\">here</a> to set medium drop speed (2).<br>"
"Click <a href=\"/D3\">here</a> to set slow drop speed (3).<br>"
"Current drop speed: #drop_speed<br><br>"
"Click <a href=\"/A0\">here</a> to not scale audio (0).<br>"
"Click <a href=\"/A1\">here</a> to scale with SIN (1).<br>"
"Click <a href=\"/A2\">here</a> to scale with reverse SIN (2).<br>"
"Click <a href=\"/A3\">here</a> to scale with LOG10 (3).<br>"
"Current scale: #ana_scale<br><br>"
"Click <a href=\"/M0\">here</a> to use scaled data only (0).<br>"
"Click <a href=\"/M1\">here</a> to mix scaled data with raw data (1).<br>"
"Current mix setting: #ana_mix<br><br>"
"Current adc data: l=#al, r=#ar, volume_filt=#volume_filt<br><br>"
"<a href=/serverIndex>Update firmware</a>";

void do_server()
{
  server.handleClient();
}

void clear_leds()
{
  for (int led = 0; led < NUM_LEDS; led++) {
    leds[0][led] = CRGB(0, 0, 0);
    leds[1][led] = CRGB(0, 0, 0);
  }
}

//char mfdata[2048]; // 1750 used!
void generate_mainForm()
{
  String buf = mainForm;
  buf.replace("#gl_volume", String(eedata.gl_volume, DEC));
  buf.replace("#brightness", String(eedata.brightness, DEC));
  buf.replace("#drop_speed", String(eedata.drop_speed, DEC));
  buf.replace("#color_sch", String(eedata.color_sch, DEC));
  buf.replace("#peak_show", String(eedata.peak_show, DEC));
  buf.replace("#ana_scale", String(eedata.ana_scale, DEC));
  buf.replace("#ana_mix", String(eedata.ana_mix, DEC));
  buf.replace("#seg8", String(eedata.seg8, DEC));
  buf.replace("#autogain", String(eedata.autogain, DEC));
  buf.replace("#al", String(lmax, DEC));
  buf.replace("#ar", String(rmax, DEC));
  buf.replace("#volume_filt", String(volume_filt, DEC));
  server.sendHeader("Connection", "close");
  server.send(200, "text/html", buf);
}

void update_drop()
{
  if (eedata.drop_speed == 0) {
    removeLedsTimeConstant = 0;
    sample_cnt = 512;
  }
  else if (eedata.drop_speed == 1) {
    removeLedsTimeConstant = 40;
    sample_cnt = 256;
  }
  else if (eedata.drop_speed == 2) {
    removeLedsTimeConstant = 10;
    sample_cnt = 256;
  }
  else if (eedata.drop_speed == 3) {
    removeLedsTimeConstant = 10;
    sample_cnt = 1024;
  }
}

#define EEMAGIC 0xCAFE1234
void update_ee()
{
  int magic = EEMAGIC;
  EEPROM.put(0, magic);
  EEPROM.put(4, eedata);
  EEPROM.commit();
}

void read_ee()
{
  eedata_st eedefaults = {
    MG_VOL, //gl_volume
    0, //color_sch
    1, //peak_show
    50,//brightness
    2, //drop_speed
    3, //ana_scale
    1, //ana_mix
    1, //seg8
    0, //autogain
  };
  
  int magic = 0;
  EEPROM.get(0, magic);
  if (magic == EEMAGIC)
    EEPROM.get(4, eedata);
  else
    memcpy(&eedata, &eedefaults, sizeof(eedata));
  update_drop();
}

void do_adc_sampling() // sample adc inputs for audio
{
  int i, l, r;
  lmax = 0;
  rmax = 0;
  lsum = 0;
  rsum = 0;
  for (i = 0; i < sample_cnt; i++) { // sample data with high rate
    l = analogRead(leftChannel);
    lsum += l;
    if (l > lmax) lmax = l;
    r = analogRead(rightChannel);
    rsum += r;
    if (r > rmax) rmax = r;
  }
  ravg = rsum / i;
  lavg = lsum / i;
}

#if 0
void do_adc_calib() // ramp up dac to achieve intact ADC sensitivity
{
  int d;
  while (d++ < DAC_LIMIT) {
    dacWrite(DAC2, d);
    delay(100);
    do_adc_sampling();
    if (lavg > CALIB_THR && ravg > CALIB_THR)
      break;
  }
}
#endif

void setup() {
  EEPROM.begin(512);
  read_ee();
  Serial.begin(115200);
  FastLED.addLeds<CHIPSET, LED_PIN_LEFT, COLOR_ORDER>(leds[0], NUM_LEDS).setCorrection( TypicalSMD5050 );
  FastLED.addLeds<CHIPSET, LED_PIN_RIGHT, COLOR_ORDER>(leds[1], NUM_LEDS).setCorrection( TypicalSMD5050 );
  FastLED.setBrightness(eedata.brightness);
  analogSetAttenuation(ADC_0db); // control sensitivity; ADC_11db, ADC_6db, ADC_2_5db, ADC_0db
  pinMode(leftChannel, INPUT);
  adcAttachPin(leftChannel);
  pinMode(rightChannel, INPUT);
  adcAttachPin(rightChannel);
  pinMode(BOARD_LED, OUTPUT); //led on board
  digitalWrite(BOARD_LED, 1);
  dacWrite(DAC2, CALIB_ADC_VAL);
  //do_adc_calib();

  WiFi.begin(ssid, password);

  int timeout = 20;
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
    if (--timeout == 0)
      break;
  }
  if (timeout) {
    Serial.println("WiFi connected.");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());
    /*use mdns for host name resolution*/
    if (!MDNS.begin(host)) { //http://esp32.local
      Serial.println("Error setting up MDNS responder!");
      while (1) {
        delay(1000);
      }
    }
    Serial.println("mDNS responder started");
    server.on("/", HTTP_GET, []() {
      generate_mainForm();
    });
    server.on("/GU", HTTP_GET, []() {
      eedata.gl_volume -= eedata.gl_volume / 10;
      update_ee();
      generate_mainForm();
    });
    server.on("/GD", HTTP_GET, []() {
      eedata.gl_volume += eedata.gl_volume / 10;
      update_ee();
      generate_mainForm();
    });
    server.on("/GH", HTTP_GET, []() {
      eedata.gl_volume = HG_VOL;
      update_ee();
      generate_mainForm();
    });
    server.on("/GM", HTTP_GET, []() {
      eedata.gl_volume = MG_VOL;
      update_ee();
      generate_mainForm();
    });
    server.on("/GL", HTTP_GET, []() {
      eedata.gl_volume = LG_VOL;
      update_ee();
      generate_mainForm();
    });
    server.on("/AG0", HTTP_GET, []() {
      eedata.autogain = 0;
      update_ee();
      generate_mainForm();
    });
    server.on("/AG1", HTTP_GET, []() {
      eedata.autogain = 1;
      update_ee();
      generate_mainForm();
    });
    server.on("/BU", HTTP_GET, []() {
      eedata.brightness += 10;
      if (eedata.brightness > 127)
        eedata.brightness = 127;
      update_ee();
      FastLED.setBrightness(eedata.brightness);
      generate_mainForm();
    });
    server.on("/BD", HTTP_GET, []() {
      eedata.brightness -= 10;
      if (eedata.brightness < 1)
        eedata.brightness = 1;
      update_ee();
      FastLED.setBrightness(eedata.brightness);
      generate_mainForm();
    });
    server.on("/BVL", HTTP_GET, []() {
      eedata.brightness = BRIGHTNESS_VLOW;
      update_ee();
      FastLED.setBrightness(eedata.brightness);
      generate_mainForm();
    });
    server.on("/BL", HTTP_GET, []() {
      eedata.brightness = BRIGHTNESS_LOW;
      update_ee();
      FastLED.setBrightness(eedata.brightness);
      generate_mainForm();
    });
    server.on("/BH", HTTP_GET, []() {
      eedata.brightness = BRIGHTNESS_HIGH;
      update_ee();
      FastLED.setBrightness(eedata.brightness);
      generate_mainForm();
    });
    server.on("/C0", HTTP_GET, []() {
      eedata.color_sch = 0;
      update_ee();
      generate_mainForm();
    });
    server.on("/C1", HTTP_GET, []() {
      eedata.color_sch = 1;
      update_ee();
      generate_mainForm();
    });
    server.on("/C2", HTTP_GET, []() {
      eedata.color_sch = 2;
      update_ee();
      generate_mainForm();
    });
    server.on("/C3", HTTP_GET, []() {
      eedata.color_sch = 3;
      update_ee();
      generate_mainForm();
    });
    server.on("/C4", HTTP_GET, []() {
      eedata.color_sch = 4;
      update_ee();
      generate_mainForm();
    });
    server.on("/C5", HTTP_GET, []() {
      eedata.color_sch = 5;
      update_ee();
      generate_mainForm();
    });
    server.on("/P0", HTTP_GET, []() {
      eedata.peak_show = 0;
      update_ee();
      generate_mainForm();
    });
    server.on("/P1", HTTP_GET, []() {
      eedata.peak_show = 1;
      update_ee();
      generate_mainForm();
    });
    server.on("/D0", HTTP_GET, []() {
      eedata.drop_speed = 0;
      update_drop();
      update_ee();
      generate_mainForm();
    });
    server.on("/D1", HTTP_GET, []() {
      eedata.drop_speed = 1;
      update_drop();
      update_ee();
      generate_mainForm();
    });
    server.on("/D2", HTTP_GET, []() {
      eedata.drop_speed = 2;
      update_drop();
      update_ee();
      generate_mainForm();
    });
    server.on("/D3", HTTP_GET, []() {
      eedata.drop_speed = 3;
      update_drop();
      update_ee();
      generate_mainForm();
    });
    server.on("/A0", HTTP_GET, []() {
      eedata.ana_scale = 0;
      update_ee();
      generate_mainForm();
    });
    server.on("/A1", HTTP_GET, []() {
      eedata.ana_scale = 1;
      update_ee();
      generate_mainForm();
    });
    server.on("/A2", HTTP_GET, []() {
      eedata.ana_scale = 2;
      update_ee();
      generate_mainForm();
    });
    server.on("/A3", HTTP_GET, []() {
      eedata.ana_scale = 3;
      update_ee();
      generate_mainForm();
    });
    server.on("/M0", HTTP_GET, []() {
      eedata.ana_mix = 0;
      update_ee();
      generate_mainForm();
    });
    server.on("/M1", HTTP_GET, []() {
      eedata.ana_mix = 1;
      update_ee();
      generate_mainForm();
    });
    server.on("/80", HTTP_GET, []() {
      eedata.seg8 = 0;
      update_ee();
      generate_mainForm();
    });
    server.on("/81", HTTP_GET, []() {
      eedata.seg8 = 1;
      update_ee();
      generate_mainForm();
    });
    
    server.on("/serverIndex", HTTP_GET, []() {
      server.sendHeader("Connection", "close");
      server.send(200, "text/html", serverIndex);
    });
    /*handling uploading firmware file */
    server.on("/update", HTTP_POST, []() {
      server.sendHeader("Connection", "close");
      server.send(200, "text/plain", (Update.hasError()) ? "FAIL" : "OK");
      ESP.restart();
    }, []() {
      static int led=0, col=1;
      HTTPUpload& upload = server.upload();
      if (upload.status == UPLOAD_FILE_START) {
        clear_leds();
        led = 0;
        leds[0][led++] = CRGB((col&2)*255, (col&1)*255, (col&4)*255);
        FastLED.show();
        upload_run = 1;
        Serial.printf("Update: %s\n", upload.filename.c_str());
        if (!Update.begin(UPDATE_SIZE_UNKNOWN)) { //start with max available size
          Update.printError(Serial);
        }
      } else if (upload.status == UPLOAD_FILE_WRITE) {
        /* flashing firmware to ESP*/
        leds[0][(led++)/10] = CRGB((col&2)*255, (col&1)*255, (col&4)*255);
        if (led==NUM_LEDS*10) {
          led=0;
          col++;
        }
        FastLED.show();
        if (Update.write(upload.buf, upload.currentSize) != upload.currentSize) {
          Update.printError(Serial);
        }
      } else if (upload.status == UPLOAD_FILE_END) {
        leds[0][(led++)/10] = CRGB((col&2)*255, (col&1)*255, (col&4)*255);
        if (led==NUM_LEDS*10) {
          led=0;
          col++;
        }
        FastLED.show();
        if (Update.end(true)) { //true to set the size to the current progress
          for (led=0; led<NUM_LEDS; led++)
            leds[0][led] = CRGB(0, 255, 0);
          FastLED.show();
          Serial.printf("Update Success: %u\nRebooting...\n", upload.totalSize);
        } else {
          Update.printError(Serial);
        }
        upload_run = 0;
      }
    });

    server.begin();
    server_ok = 1;
  }
  digitalWrite(BOARD_LED, 0);
}

CRGB get_color(int led)
{
  CRGB r;
  if (eedata.color_sch == 0) {
    if (led < middleColorLED) {
      r = CRGB(map(led, 0, middleColorLED - 1, 0, 255) , 255, 0);
    } else {
      r = CRGB(255, map(led, middleColorLED, NUM_LEDS - 1, 255, 0), 0);
    }
  } else if (eedata.color_sch == 1) {
    if (led < middleColorLED) {
      r = CRGB(0, 0, map(led, 0, middleColorLED - 1, 200, 255));
    } else {
      r = CRGB(map(led, middleColorLED, NUM_LEDS - 1, 0, 255), 0, map(led, middleColorLED, NUM_LEDS - 1, 255, 0));
    }
  } else if (eedata.color_sch == 2) {
    if (led < middleColorLED) {
      r = CRGB(80, 160, map(led, 0, middleColorLED - 1, 160, 255));
    } else {
      r = CRGB(map(led, middleColorLED, NUM_LEDS - 1, 80, 255), 160, map(led, middleColorLED, NUM_LEDS - 1, 255, 0));
    }
  } else if (eedata.color_sch == 3) {
    if ((led < 50 && !eedata.seg8) || (led < 5*8 && eedata.seg8)) {
      r = CRGB(90, 150, 180);//CRGB(110, 170, 210);
    } else {
      r = CRGB(200, 0, 0);
    }
  } else if (eedata.color_sch == 4) {
    if (led < middleColorLED) {
      r = CRGB(0, 255, map(led, 0, middleColorLED - 1, 0, 80));
    } else {
      r = CRGB(map(led, middleColorLED, NUM_LEDS - 1, 0, 255), 2550, map(led, middleColorLED, NUM_LEDS - 1, 80, 0));
    }
  } else if (eedata.color_sch == 5) {
    if (led < 5*8) {
      r = CRGB(200, 120, 00);
    } else {
      r = CRGB(255, 0, 0);
    }
  }
  return r;
}

#define FILTER_RATIO 0 // 0 is unfiltered, 99 is maximum slow
float  nonLinearResponseFactor = 90 / (float) (NUM_LEDS * 10);
float  log10MaxDisplaySegments = log10(NUM_LEDS * 10);

//#define DBG_PRINT
#define RD_HYST 20
#define RDCNT_MAX 50
#define MAX_AUTOGAIN 60
#define AG_DELAY 100
#define AG_CORRECT 1.6
#define AG_FILT 3 // of 1000

int lrdcnt, rrdcnt;
long int last;

void loop() {
  int i, ledsToLight[2], ledsN[2];
  int volume = eedata.gl_volume;
  int l, r;

  do_adc_sampling();
  l = max(0, lmax+ADC_OFFSET_L);
  r = max(0, rmax+ADC_OFFSET_L);
  
  if (eedata.autogain) {
    if (l > volume-RD_HYST || r > volume-RD_HYST) {
      volume_filt = max(l, r)+RD_HYST;
      lmax_lterm = l;
      rmax_lterm = r;
      lrdcnt = AG_DELAY;
      rrdcnt = AG_DELAY;
    }
    else {
      volume_filt = (volume_filt*(1000-AG_FILT) + AG_FILT*max(lmax_lterm, rmax_lterm))/1000;
    }
    if (l > lmax_lterm) {
      lmax_lterm = l;
      lrdcnt = AG_DELAY;
    }
    if (r > rmax_lterm) {
      rmax_lterm = r;
      rrdcnt = AG_DELAY;
    }
    if (lrdcnt == 0) {
      lmax_lterm--;
    }
    else 
      lrdcnt--;
    if (rrdcnt == 0) {
      rmax_lterm--;
    }
    else 
      rrdcnt--;
    volume = volume_filt * AG_CORRECT;
    eedata.gl_volume = volume; // make change visible in web
  }
#ifdef DBG_PRINT
  Serial.println("cyclic ms:");
  Serial.println(millis() - last);
  last = millis();
  Serial.println("max:");
  Serial.println(rmax);
  Serial.println(lmax);
  Serial.println("avg:");
  Serial.println(rmax);
  Serial.println(lmax);
  Serial.println("single:");
  Serial.println(r);
  Serial.println(l);
#endif
  // choose max or avg
  ledsToLight[0] = (ledsToLight[0] * (FILTER_RATIO) + (100 - FILTER_RATIO) * map(l, 0, volume, 0, NUM_LEDS * 10)) / 100;
  ledsToLight[1] = (ledsToLight[1] * (FILTER_RATIO) + (100 - FILTER_RATIO) * map(r, 0, volume, 0, NUM_LEDS * 10)) / 100;

  // scaling and updating VU LEDs
  for (i = 0; i < 2; i++) {
    // if defined, convert to (reverse) non linear response
    boolean flagNonLinear = false;

    if (eedata.ana_scale==1) {
      flagNonLinear = true;
      ledsN[i] = ((sin(((ledsToLight[i] * nonLinearResponseFactor) + 270) * 0.0174533) + 1) * NUM_LEDS * 10);
    }
    else if (eedata.ana_scale==2){
      flagNonLinear = true;
      ledsN[i] = ((sin(((ledsToLight[i] * nonLinearResponseFactor)) * 0.0174533)) * NUM_LEDS * 10);
    }
    else if (eedata.ana_scale==3){
      flagNonLinear = true;
      ledsN[i] = ((log10(ledsToLight[i]  + 1) / log10MaxDisplaySegments * NUM_LEDS * 10));
    }

    if (flagNonLinear == true) {
      if (eedata.ana_mix)
        ledsToLight[i] = (ledsToLight[i] + ledsN[i]) / 2;
      else
        ledsToLight[i] = ledsN[i];
    }

    if (removeLedsTimeConstant) {
      if (ledsToLight[i] >= numLedsToLight[i]) {
        numLedsToLight[i] = ledsToLight[i];
      } else if (ledsToLight[i] < numLedsToLight[i]) {
        numLedsToLight[i] -= removeLedsTimeConstant;
        //          digitalWrite(2, (toggle++)&1);
      }
    } else {
      numLedsToLight[i] = ledsToLight[i];
    }

    if (numLedsToLight[i] < 1) {
      numLedsToLight[i] = 0;
    }
    if (numLedsToLight[i] >= NUM_LEDS * 10) {
      numLedsToLight[i] = NUM_LEDS * 10 - 10;
    }
    if (numLedsToLight[i] / 10 > peakpos[i]) {
      peakpos[i] = numLedsToLight[i] / 10;
      peaktime[i] = millis() + PEAK_TIME;
    }

    if (eedata.seg8) {
      numLedsToLight[i] = numLedsToLight[i]*8/640;
      numLedsToLight[i] = numLedsToLight[i]*80;
    }
    for (int led = 0; led < numLedsToLight[i] / 10; led++) {
      leds[i][led] = get_color(led);
      if (eedata.seg8 && (led % 8 == 7))
        leds[i][led] = CRGB(0, 0, 0);
    }
    for (int led = NUM_LEDS - 1; led >= numLedsToLight[i] / 10; led--) {
      leds[i][led] = CRGB(0, 0, 0);
    }
    if (eedata.peak_show)
    {
      int led = peakpos[i];
      if (led) {
        leds[i][led] = get_color(led);
        if (eedata.seg8) {
          led = led*8/64;
          led *= 8;
          for (int j=0; j<7; j++)
            leds[i][led+j] = get_color(led);
          leds[i][led+7] = CRGB(0, 0, 0);
        }
      }
      if (millis() >= peaktime[i]) {
        peaktime[i] = millis() + PEAK_TIME;
        peakpos[i] = 0;
      }
    }
  }
  if (upload_run)
    clear_leds();
  FastLED.show();
  if (server_ok)
    do_server();
}
